#include <8051.h> // Defining SFRs
#include "uart.c"

// ISR Prototypes ===================================================
void INT0_ISR(void) __interrupt 0; // ISR for External Interrupt 0
void T0_ISR(void)   __interrupt 1; // ISR for Timer0/Counter0 Overflow Interrupt
void INT1_ISR(void) __interrupt 2; // ISR for External Interrupt 1
void T1_ISR(void)   __interrupt 3; // ISR for Timer1/Counter1 Overflow Interrupt
void UART_ISR(void) __interrupt 4; // ISR for UART Interrupt

#define Trig P1_0
#define Echo P1_1

unsigned int Utrasonic_Distance_Sensor()
{
Trig=1;TH0=0;TL0=0;Trig=0;
while(Echo==0);TR0=1;
while(Echo==1);TR0=0;
return(TH0*256+TL0);
}

void main(void)
{
uart_initialize();
TH1=0xE6; // Set Baud Rate to 1200 bps for 12M Hz
TMOD&=0xF1;TMOD|=0x01;	// Set Timer0 to 16-bit timer
uart_put_string("hello");
while(1)
	{
	uart_put_string("Distance: ");
	uart_put_integer(Utrasonic_Distance_Sensor()/58);
	uart_put_string(" cm\n\r");
	}
}


void INT0_ISR(void) __interrupt 0
{}
void T0_ISR(void) __interrupt 1
{}
void INT1_ISR(void) __interrupt 2
{}
void T1_ISR(void) __interrupt 3
{}
void UART_ISR(void) __interrupt 4
{}